'' System Version 2.002
'' OS_windowEditor Changes:
''
''   2006/09/24 - Initial version with change dates
''   2006/12/10 - Changed for common display interface

'' This object contains the display window editor and the text file editor for the
'' Parallax OS and is (c) 2006 by Michael Green.
'' Permission is given to include this or portions of this program in any program
'' for the Parallax Propeller processor as long as proper credit is given.

OBJ
  ldr : "OS_loader"
  dsp : "OS_dspText"
  key : "OS_keyboard"

PUB windowEditor : input | p, c, x, y

'' This method provides an editable window on the display text screen.
'' It uses the standard PS/2 keyboard control keys including backspace,
'' cursor positioning, delete and insert (for an insert mode). This uses
'' the active window in the hires dsp text object to set the bounds of the
'' window to be used.  It is the responsibility of the caller to define
'' and clear the window, set the cursor position, and enable the cursor.
'' The edited text must be retrieved from the window by the caller.
'' Unknown or invalid control keys terminate editing and return the keycode.
'' The state of the window and the screen is such that editing can be
'' resumed after the terminating keycode is processed by the caller.

  p := long[ldr#videoPtr]
  repeat
    x := dsp.windowCol
    y := dsp.windowRow
    c := dsp.windowChar(x,y)
    dsp.setWindowChar(x,y,$5F,dsp#NoChgColor)  ' Display underline
    input := key.getKey
    dsp.setWindowChar(x,y,c,dsp#NoChgColor)    ' Restore character
    case input
      $09:                                     ' Tab
        repeat
          if byte[p+dsp#dsp_states] & dsp#dsp_Insert
            dsp.out(dsp#Insert)
          dsp.out(" ")
        while (byte[p+dsp#dsp_col] - byte[p+dsp#dsp_wleft]) & 7
      $0D:                                     ' Return
        if byte[p+dsp#dsp_row] - byte[p+dsp#dsp_wtop] == byte[p+dsp#dsp_wrows] - 1
          return
        dsp.out(dsp#Cr)
      $20..$7F:                                ' Printable characters
        if byte[p+dsp#dsp_states] & dsp#dsp_Insert
          dsp.out(dsp#Insert)
        dsp.out(input)
      $C0:                                     ' Left arrow
        dsp.out(dsp#CursLt)
      $C1:                                     ' Right arrow 
        dsp.out(dsp#CursRt)                            
      $C2:                                     ' Up arrow
        if byte[p+dsp#dsp_row] == byte[p+dsp#dsp_wtop]
          return
        if byte[p+dsp#dsp_wrows] == 1
          return
        dsp.out(dsp#CursUp)
      $C3:                                     ' Down arrow
        if byte[p+dsp#dsp_row] - byte[p+dsp#dsp_wtop] == byte[p+dsp#dsp_wrows] - 1
          return
        if byte[p+dsp#dsp_wrows] == 1
          return
        else
          dsp.out(dsp#CursDn)
      $C4:                                     ' Home
        if byte[p+dsp#dsp_wrows] == 1
          return
        else
          dsp.out(dsp#Home)
      $C5:                                     ' End
        if byte[p+dsp#dsp_wrows] == 1
          return
        else
          dsp.out3(dsp#MoveXY,dsp#Alt00,dsp.maxRows)
      $C8:                                     ' Backspace
        if byte[p+dsp#dsp_col] > byte[p+dsp#dsp_wleft]
          dsp.out(dsp#Bsp)
      $C9:                                     ' Delete
        dsp.out(dsp#Delete)
      $CA:                                     ' Insert
        byte[p+dsp#dsp_states] ^= dsp#dsp_Insert
      other:                                   ' All others
        return